#ifndef GENERAL_H
#define GENERAL_H

#include <netinet/in.h>
#include "mrmp.h"

extern "C" {
#if !defined(SOLARIS)
#include <strings.h>
#endif
#include <unistd.h>
#include <ctype.h>
#include <fcntl.h>
#include <sys/wait.h>
#if defined(SOLARIS)
extern int gethostname(char*,int);
#endif
#define _MTCP_IMPLEMENTATION
#include "mtcp.h"
}

#include <iostream.h>
#include <iomanip.h>
#include <fstream.h>
#include <strstream.h>

#include "IOManip.h"
#include "IOUtil.h"
#include "Defines.h"

extern int s_pipe(int*);
extern int readn(int, void*, int);
extern int writen(int, void*, int);
extern void set_fl(int, int);
extern void clr_fl(int, int);

typedef void (*CALLBACK_VOID)();
typedef void (*CALLBACK_INT)(int);

CALLBACK_INT SIGNAL_RESTART(int, CALLBACK_INT);
CALLBACK_INT SIGNAL_INTERRUPT(int, CALLBACK_INT);

#endif
