#ifndef ITERATOR_H
#define ITERATOR_H

#include "General.h"
#include "Collectable.h"

class ITERATOR : public COLLECTABLE {
private:
protected:
public:
  virtual COLLECTABLE* operator++() = 0; // Prefix.
  virtual COLLECTABLE* operator++(int) = 0; // Postfix.
  virtual COLLECTABLE* operator()() = 0;
  virtual COLLECTABLE* findNext(const COLLECTABLE*) = 0;
  virtual void reset() = 0;
};

#endif
