#ifndef MTCP_H
#define MTCP_H

#include "General.h"
#include "IPC.h"
#include "MTCP_SERVER.h"

class MTCP {
  /* C++ MultiTCP API */
public:
  static void  Init();
  static pid_t Fork();
  static int   Socket(int, int, int);
  static int   Connect(int, struct sockaddr*, int);
  static int   SetSockOpt(int, int, int, char*, int);
  static int   GetSockOpt(int, int, int, char*, int*);
  static int   GetPeerName(int, struct sockaddr*, int*);
  static int   GetSockName(int, struct sockaddr*, int*);
  static int   Close(int);
  static int   Bind(int, struct sockaddr*, int);
  static int   Accept(int, struct sockaddr*, int*);
  static void  BeginMessage(int);
  static void  EndMessage(int);
  static int   Write(int, char*, unsigned int);
};

#endif
